// StopLightPanel class for CSCI 201 StopLight lab

// (c) J. Dean Brock, 2004
// Department of Computer Science
// UNC Asheville

// Based on C++ StopLight
// (c) J. Dean Brock, 1998

package edu.unca.cs.csci201.LabAids;

import java.awt.* ;
import java.awt.event.* ;
import javax.swing.JLabel ;

/**
 * Stop light panel with two traffic signals
 */
public class StopLightPanel extends javax.swing.JPanel {
    
    // Craete the displays
    StopLightDisplay EWLight ;
    StopLightDisplay NSLight ;
    StopLightControl slControl ;

    /**
     * Stop light panel constructor
     */
    public StopLightPanel() {
        setPreferredSize(new java.awt.Dimension(400, 600)) ;
        
        // Create the displays
        EWLight = new StopLightDisplay() ;
        NSLight = new StopLightDisplay() ;
        slControl = new StopLightControl(NSLight, EWLight) ;
        
        // Create the labels
        JLabel EWLabel = new JLabel("EW", JLabel.CENTER) ;
        JLabel NSLabel = new JLabel("NS", JLabel.CENTER) ;
        Font labFont = new Font("Helvetica", Font.PLAIN, 50) ; 
        EWLabel.setFont(labFont) ;
        NSLabel.setFont(labFont) ;
        
        // Create the GridBag constraints
        GridBagConstraints lightConstraint = new GridBagConstraints() ;
        lightConstraint.fill = GridBagConstraints.BOTH ;
        lightConstraint.weightx = 100.0 ;
        lightConstraint.weighty = 100.0 ;
        lightConstraint.ipadx = 10 ;
        lightConstraint.ipady = 10 ;
        
        GridBagConstraints labelConstraint = new GridBagConstraints() ;
        labelConstraint.fill = GridBagConstraints.BOTH ;
        
        // Add the stuff in       
        GridBagLayout theGrid = new GridBagLayout() ;        
        setLayout(theGrid) ;
        add(EWLight, lightConstraint) ;
        lightConstraint.gridwidth = GridBagConstraints.REMAINDER ;
        add(NSLight, lightConstraint) ;
        add(EWLabel, labelConstraint) ;
        labelConstraint.gridwidth = GridBagConstraints.REMAINDER ;
        add(NSLabel, labelConstraint) ;
    }
    
    /**
     * Return the stop light control
     * @return Stop light control -- one per stop light
     */
    public StopLightControl getControl() {
        return slControl ;
    }
}
